# HaskellPlayground

Experiment with Haskell language.

## Work with Haskell

### Compile

`ghc mymainfile`

### Interactive

`ghci mymainfile`

## Follow lessons

Get the code file names according to the slide of the official PFONC lab course.

The considered slideshow contains 78 slides.

These files are in the `cm` folder.

### Slide 10

File `guard.hs`

### Slide 15

`mypower.hs` defines `e1` and `e2`.

`myfibo.hs` defines `fibo`.

### Slide 16

`hpal.hs`

### Slide 22

`logic.hs`

### Slide 23

`geometry.hs`

### Slide 28

`peano.hs`

### Slide 29

`list.hs` and `tree.hs`

### Slide 31

`tripy.hs`

### Slide 32

`listfct.hs`

### Slide 37

`myflip.hs`

### Slide 41

`anagram.hs`

### Slide 42

`prime.hs` with functions `dividersf` and `primerf`.

### Slide 46

`fold.hs`

### Slide 50

`prime.hs` with function `primeinf`.

### Slide 55

`io_rev.hs` and `io_shuffle.hs` to compile

### Slide 57

`io_length.hs` to compile

### Slide 58

`io_cesar.hs` to compile
